var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    cnvBackBuffer=document.getElementById("backBuffer");
    cntxBackBuffer=cnvBackBuffer.getContext("2d");
    showAppTitle();
    
    imgLogo=document.getElementById("Logo");
    img=document.getElementById("imgToShow");
    
    initialValues();
    InitialiseCaptions();
    for(var i=0;i<NoOfCategories;i++){
        SelectedImage[i]=0;
    }
    InitialiseImageFileNames();
    initialiseGUI();
    nxtStepLeft=8;
    nxtStepTop=BottomPanelTop+20;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");

    initialiseEvents();
    drawBasicScreen();
}
    
function initialiseEvents(){
    $("#visualisation").contextmenu(function(evt){
        evt.preventDefault();
        evt.stopPropagation();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove(evt);
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp(evt);
    });
    
    $("#visualisation").on("mouseout",function(evt){
        imgLogo=document.getElementById("Logo");
        drawBasicScreen();
    });
}

function InitialiseImageFileNames(){
    FileName[0]="BTNEdu";
    FileName[1]="BTNWork";
    FileName[2]="BTNCommerce";
    FileName[3]="BTNGovernment";
    FileName[4]="BTNMedicine";
}

function initialValues(){
    width=canvas.width;
    height=canvas.height;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    SectionTitle=BottomPanelTop-20;
    BTNTop=TopPanelHeight+Column1Left;
}

function initialiseGUI(){
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    imgLogo=document.getElementById("Logo");
    for(var i=0;i<NoOfCategories;i++){
        imgButtons[i]=document.getElementById(FileName[i]+"2");
        imgButtonsHovered[i]=document.getElementById(FileName[i]+"1");
        ButtonHover[i]=false;
    }
    InitialiseGUI_values();
}

function InitialiseGUI_values(){
    ImageTop=TopPanelHeight+imgButtons[0].height+Column1Top;
}

function drawBasicScreen(){
    //Φόντα οθόνης
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    cntx.fillStyle=MainAreaColor;
    cntx.fillRect(0,0,width,height);

    cntx.fillStyle=PanelColor;
    cntx.fillRect(0,0,width,TopPanelHeight);
    cntx.fillRect(0,BottomPanelTop,width,BottomPanelHeight);
    //Τίτλος εφαρμογής
    cnvsWrite(LetterColor,25,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    //Κουμπιά
    var BTNLeft=Column1Left,BTNTop=TopPanelHeight+Column1Top;
    for(var i=0;i<NoOfCategories;i++){
        if(ButtonHover[i]){
            cntx.drawImage(imgButtonsHovered[i],BTNLeft,BTNTop);
        }
        else{
            cntx.drawImage(imgButtons[i],BTNLeft,BTNTop);
        }
        BTNTop=BTNTop+imgButtons[i].height+Column1Top;
    }
    drawButtonNext();

    //Εικόνες
    var imgMainLeft=(width+BTNLeft+imgButtons[0].width-iw)/2;
    var imgMainTop=(BottomPanelTop-TopPanelHeight-ih)/2+TopPanelHeight;
    
    cntxBackBuffer.drawImage(img,0,0);
    ShowCaption();

    if(iw>0){
    	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
    	if(DrawingFinished){
            cntx.putImageData(imgData,imgMainLeft,imgMainTop);
    	}
    	else{
            timerLoop=setInterval(
                    function(){
                        drawSelectedImage(imgMainLeft,imgMainTop);
                    },
                    simSpeed);
    	}
    }
    
    cnvsWrite(LetterColor,fontSize-10,"Arial",-1,BottomPanelTop+67,"Κάνε διαδοχικά κλικ σε μια κατηγορία για να δεις ένα νέο παράδειγμα.");    

    //Πλαίσια μαύρου χρώματος
    cntx.strokeStyle="rgb(0,0,0)";
    cntx.beginPath();
    cntx.rect(0,0,width-1,TopPanelHeight);
    cntx.rect(0,TopPanelHeight,width-1,height-TopPanelHeight-BottomPanelHeight);
    cntx.rect(0,BottomPanelTop,width-1,BottomPanelHeight-1);
    if(iw>0){
        cntx.rect(imgMainLeft-1,imgMainTop-1,iw+1,ih+1);
    }
    cntx.stroke();
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function drawSelectedImage(imgMainLeft,imgMainTop){
	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
	switch(effectSlctr){
	case 0:
	    effFadeIn();
		break;
	case 1:
		effHorizontal();
		break;
	case 2:
	    effVertical();
		break;
	case 3:
	    effRgbEffect();
		break;
	case 4:
	    effCircleEffect();
	    break;
        break;
	}
	//
	cntx.putImageData(imgData,imgMainLeft,imgMainTop);
}

function effFadeIn(){
	imgOpacity+=20;
	if(imgOpacity>255){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=3;i<imgData.data.length;i+=4){
			imgData.data[i]=imgOpacity;
		}
	}
}

function effHorizontal(){
	var noOfPixels=iw*ih;
	visiblePixels+=iw;
	if(visiblePixels>noOfPixels/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=visiblePixels;i<noOfPixels-visiblePixels;i++){
			imgData.data[4*i+3]=0;
		}
	}
}

function effVertical(){
	visibleColumns+=2;
	if(visibleColumns>iw/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<=ih;i++){
			for(var j=visibleColumns;j<=iw-visibleColumns;j++){
				imgData.data[((i-1)*iw+j)*4+3]=0;
			}
		}
	}
}

function effRgbEffect(){
	rgbEffectStage++;
	if(rgbEffectStage>2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<iw*ih;i++){
			for(var component=rgbEffectStage;component<3;component++){
				imgData.data[4*i+component]=0;
			}
		}
	}
}

function effCircleEffect(){
    effectRadius+=10;
    if(effectRadius>Math.sqrt(Math.pow(iw,2)+Math.pow(ih,2))/radiusDenominatior){
        DrawingFinished=true;
        clearInterval(timerLoop);
    }
    else{
        for(var i=0;i<=ih;i++){
            for(var j=0;j<=iw;j++){
                var r=Math.sqrt(Math.pow(i-yCenterOffset,2)+Math.pow(j-xCenterOffset,2));
                if(r>effectRadius){
                    imgData.data[4*((i-1)*iw+j)+3]=0;
                }
            }
        }
    }
}

function getImagesData(){
    imgData=cntx.getImageData(width+10,10,iw,ih);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (ButtonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function ButtonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseMove(evt){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
        ShowProgramID=false;
    }
    
    for(var i=0;i<NoOfCategories;i++) {
        ButtonHover[i]=false;
        if (mx>=Column1Left && mx<=Column1Left+imgButtons[i].width){               
            if (my>TopPanelHeight+(i+1)*Column1Top+i*imgButtons[i].height && my<TopPanelHeight+i*Column1Top+(i+1)*imgButtons[i].height) ButtonHover[i]=true;
        }
    }
    
    if(DrawingFinished)drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(evt){
    evt.preventDefault();
    isButtonPressed=false;
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        if(MyInfo){
            ShowProgramID=!ShowProgramID;
        }
        else {
            showHTML();
        }
        drawBasicScreen();
    }
    
    if(DrawingFinished){
        var Found=false;

        if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight){
            Found=true;
        }
        
        var i=0;
        while(i<NoOfCategories && !Found){
            if (ButtonHover[i]){
                Found=true;
                SelectedCategory=i;
            }
            else {
                i++;
            }
        }
        if(Found){
            OpaquePercent=0;
            SelectImage(SelectedCategory);
            NextPic=true;
        }
        drawBasicScreen();
    }
}

function SelectImage(i){
    var SelectedFile;
    var AvailableFiles,FileNo;
    
    if(i==0){
        SelectedFile="elearning";
        AvailableFiles=8;
    }
    else if(i==1){
        SelectedFile="teleworking";
        AvailableFiles=8;
    }
    else if(i==2){
        SelectedFile="ecommerce";
        AvailableFiles=12;
    }
    else if(i==3){
        SelectedFile="eGovernment";
        AvailableFiles=7;
    }
    else{
        SelectedFile="emedicine";
        AvailableFiles=5;
    }
    do{
        FileNo=parseInt(Math.random()*AvailableFiles+1);
    }while(FileNo==SelectedImage[i] || FileNo>AvailableFiles);
    SelectedImage[i]=FileNo;
    
    var downloadingImage=new Image();
    downloadingImage.onload=function(){
        img.src=this.src;
        iw=img.width;
        ih=img.height;
    	DrawingFinished=false;
    	selectEffect();
        drawBasicScreen();
    };
    
    //φόρτωση επιλεγμένης εικόνας
    downloadingImage.src="img/PIC"+SelectedFile+FileNo+".jpg";
    
    captionToShow=AvailableCaptions[i][FileNo-1];
}

function ShowCaption(){
    if(captionToShow!=""){
        cnvsWrite(LetterColor,16,"Arial",-1,BottomPanelTop+20,Sections[SelectedCategory]);
        cnvsWrite(LetterColor,18,"Arial",-1,BottomPanelTop+42,captionToShow);
    }
}

function InitialiseCaptions(){
    Sections[0]="Τηλε-Εκπαίδευση";
    Sections[1]="Τηλε-Εργασία";
    Sections[2]="Ηλεκτρονικό Εμπόριο";
    Sections[3]="Ηλεκτρονική Διακυβέρνηση";
    Sections[4]="Τηλε-Ιατρική";
    AvailableCaptions[0][0]="Δικτύωση για το βοήθεια της μάθησης";
    AvailableCaptions[0][1]="Διδασκαλία από απόσταση";
    AvailableCaptions[0][2]="Τα συστατικά της μάθησης από απόσταση";
    AvailableCaptions[0][3]="Παλιές και νέες μέθοδοι μάθησης συνδυάζονται";
    AvailableCaptions[0][4]="Η ηλεκτρονική μάθηση μπορεί να συμβάλλει στην εξειδίκευση";
    AvailableCaptions[0][5]="Ο Υπολογιστής γίνεται μια ακόμη πηγή γνώσης";
    AvailableCaptions[0][6]="Η οθόνη του Υπολογιστή γίνεται προέκταση των βιβλίων";
    AvailableCaptions[0][7]="Οι εφαρμογές δεν έχουν όρια";
    AvailableCaptions[0][8]="";
    AvailableCaptions[0][9]="";
    AvailableCaptions[0][10]="";
    AvailableCaptions[0][11]="";        
    AvailableCaptions[1][0]="Συν-Εργασία (και) μέσω του Υπολογιστή";
    AvailableCaptions[1][1]="Ο καθένας μπορεί να εργαστεί από οπουδήποτε";
    AvailableCaptions[1][2]="Εργασία από το σπίτι";
    AvailableCaptions[1][3]="Εργασία όπου, όποτε και όπως μας εξυπηρετεί";
    AvailableCaptions[1][4]="Εργασία από την άνεση του σπιτιού μας";
    AvailableCaptions[1][5]="Πολλοί τρόποι επικοινωνίας - πολλοί τρόποι Συν-Εργασίας";
    AvailableCaptions[1][6]="Άνεση στην εργασία";
    AvailableCaptions[1][7]="Εργασία σε... οικιακούς ρυθμούς";
    AvailableCaptions[1][8]="";
    AvailableCaptions[1][9]="";
    AvailableCaptions[1][10]="";
    AvailableCaptions[1][11]="";
    AvailableCaptions[2][0]="Το εμπόριο ''ψηφιοποιείται''";
    AvailableCaptions[2][1]="Παραγγελίες από απόσταση";
    AvailableCaptions[2][2]="Ηλεκτρονική υπεραγορά";
    AvailableCaptions[2][3]="Το ψηφιακό καλάθι";
    AvailableCaptions[2][4]="Οι αγορές γίνονται από το σπίτι";
    AvailableCaptions[2][5]="Αγορές μέσω υπολογιστή";
    AvailableCaptions[2][6]="Ηλεκτρονική παραγγελία προϊόντων και υπηρεσιών";
    AvailableCaptions[2][7]="Ευκολία στις αγορές";
    AvailableCaptions[2][8]="Ψώνια με ευκολία";
    AvailableCaptions[2][9]="Ψώνια με ασφάλεια";
    AvailableCaptions[2][10]="Ηλεκτρονικό εμπόριο";
    AvailableCaptions[2][11]="Το ψηφιακό καλάθι";
    AvailableCaptions[3][0]="Ψηφιακές ευκολίες για τον πολίτη";
    AvailableCaptions[3][1]="Εξυπηρέτηση του πολίτη όπου κι αν βρεθεί";
    AvailableCaptions[3][2]="Ηλεκτρονική διακυβέρνηση";
    AvailableCaptions[3][3]="Ηλεκτρονική Υδρόγειος";
    AvailableCaptions[3][4]="Όλες οι υπηρεσίες στην οθόνη του Υπολογιστή μας";
    AvailableCaptions[3][5]="Οι πυλώνες της ηλεκτρονικής διακυβέρνησης";
    AvailableCaptions[3][6]="Πλεονεκτήματα της ηλεκτρονικής διακυβέρνησης";
    AvailableCaptions[3][7]="";
    AvailableCaptions[3][8]="";
    AvailableCaptions[3][9]="";
    AvailableCaptions[3][10]="";
    AvailableCaptions[3][11]="";
    AvailableCaptions[4][0]="Ο γιατρός πάντα κοντά μας";
    AvailableCaptions[4][1]="Ο υπολογιστής γίνεται εργαλείο διάγνωσης";
    AvailableCaptions[4][2]="Τηλε-εξέταση ασθενούς";
    AvailableCaptions[4][3]="Ο γιατρός ''συνδέεται'' με τον ασθενή";
    AvailableCaptions[4][4]="Τα νέα εργαλεία της ιατρικής επιστήμης συμπληρώνουν τα κλασικά";
    AvailableCaptions[4][5]="";
    AvailableCaptions[4][6]="";
    AvailableCaptions[4][7]="";
    AvailableCaptions[4][8]="";
    AvailableCaptions[4][9]="";
    AvailableCaptions[4][10]="";
    AvailableCaptions[4][11]="";
}

function selectEffect(){
    //Επιλογή εφφέ
    effectSlctr=parseInt(Math.random()*noOfEffects);
    //Αρχικοποίηση παραμέτρων
    imgOpacity=0;
    visiblePixels=0;
    visibleColumns=0;
    rgbEffectStage=-1;
    effectRadius=0;
    simSpeed=10;
    switch(effectSlctr){
        case 3: //rgb
            simSpeed=200;
            break;
        case 4: //circle
            var centerSlctr=Math.random();
            if(centerSlctr<0.33){
                xCenterOffset=0;
                yCenterOffset=0;
                radiusDenominatior=1;
            }
            else if(centerSlctr<0.66){
                xCenterOffset=iw/2;
                yCenterOffset=ih/2;
                radiusDenominatior=2;
            }
            else{
                xCenterOffset=iw;
                yCenterOffset=ih;
                radiusDenominatior=1;
            }
            break;
    }
}